POJ-3126--Prime Path---BFS广搜

来源:互联网 发布:中国行政区数据库 编辑:程序博客网 时间:2024/04/29 04:29

Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题意:给两个数a,b,从a到b进行转换,每次只能修改一个位的数字,并且转换后的数必须是素数,问从a到b进行转换需要的最小的步骤数。

解题思路:我用了一个筛选法打了一个素数表,打到100000即可,给的数字一定是四位数。然后每次修改一个位数之后入队,然后枚举直到找到b为止。有个地方需要注意,千位数不能为0.

#include<iostream>#include<cstdio>#include<cstring>#include<queue>using namespace std;const int M=1e5+10;int ha[M+50];int num[M+50];int flag[M+50];void bfs(int x,int y){    queue<int>q;    q.push(x);    flag[x]=1;    while(!q.empty())    {        int z=q.front();        q.pop();        if(z==y)            break;        int a=z/1000,b=z/100%10,c=z%100/10,d=z%10;        for(int i=0; i<=9; i++)        {            if(!ha[a*1000+b*100+c*10+i]&&!flag[a*1000+b*100+c*10+i])            {                q.push(a*1000+b*100+c*10+i);                flag[a*1000+b*100+c*10+i]=1;                num[a*1000+b*100+c*10+i]=num[z]+1;            }            if(!ha[a*1000+b*100+i*10+d]&&!flag[a*1000+b*100+i*10+d])            {                q.push(a*1000+b*100+i*10+d);                flag[a*1000+b*100+i*10+d]=1;                num[a*1000+b*100+i*10+d]=num[z]+1;            }            if(!ha[a*1000+i*100+c*10+d]&&!flag[a*1000+i*100+c*10+d])            {                q.push(a*1000+i*100+c*10+d);                flag[a*1000+i*100+c*10+d]=1;                num[a*1000+i*100+c*10+d]=num[z]+1;            }            if(!ha[i*1000+b*100+c*10+d]&&!flag[i*1000+b*100+c*10+d]&&i!=0)            {                q.push(i*1000+b*100+c*10+d);                flag[i*1000+b*100+c*10+d]=1;                num[i*1000+b*100+c*10+d]=num[z]+1;            }        }//四个if有点庞大,但是简单粗暴易于观看。    }}int main(){    int i,j;//筛选打素数表    for(i=2; i*i<=M; i++)        for(j=i*i; j<M; j+=i)            ha[j]=1;    int T;    cin>>T;    while(T--)    {        int x,y;        cin>>x>>y;        memset(num,0,sizeof(num));        memset(flag,0,sizeof(flag));        bfs(x,y);        cout<<num[y]<<endl;    }}
原创粉丝点击